Ruby - Bug #18486

Enumerable#group_by ordering appears to have changed and doesn't
01/13/2022 04:05 PM - masukomi@masukomi.org (kay rhodes)

match docs.

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: 3.0.2 Backport:

2.6: UNKNOWN, 2.7: UNKNOWN, 3.0:
UNKNOWN, 3.1: UNKNOWN

Description
The documentation for Enumerable#group_by suggests the following:

(1..6).group_by { [i| i%3} #=>{0=>[3, 6], 1=>[1, 4], 2=>[2, 5]}
it actually produces this (same values different order). Tested in 2.6.3 and 3.0.2

(1..6).group_by { i i%3} #=>{1=>[1, 4], 2=>[2, 5], 0=>[3, 6]}

as hash table ordering is something people depend on these days | wonder if the reordering of the keys may be more than just a

minor documentation bug.

I noticed this in 2.6.3. Assuming the docs matched reality when written this implies we've been living with this for a while. | don't know

how long before that this actually changed.

History

#1 - 01/13/2022 04:31 PM - jeremyevans0 (Jeremy Evans)

This is only a minor documentation issue. | assume the documentation is a left over from pre-1.9, when

#2 - 01/13/2022 04:33 PM - jeremyevans0 (Jeremy Evans)
- Status changed from Open to Closed

This was already fixed in 1€10099e091

#3 - 01/13/2022 04:34 PM - zverok (Victor Shepelev)

| think it is docs bug.
group_by emerged in Ruby 1.8.7, but my RVM can't install it :(
The earliest | could check was 1.9.3, and it already has order of keys 1, 2, 0.

| think it is a natural reason of keys being in the order they are inserted: the first value for grouping is 1 (1

result.

With the preservation of Hash keys order introduced at 1.9, | think that's when the behavior changed :)))
In Ruby 1.8.6, imitation of group_by with inject does the initially documented order:

(1..6) .to_a.inject ({}) { Ilr, il (r[i
# =

i %3] II=11) << ij r}
> {0=>[3, 6], 1=>[1, 4], 2=>[2, 5]}

#4 - 01/13/2022 07:12 PM - matsuda (Akira Matsuda)

group_by emerged in Ruby 1.8.7, but my RVM can't install it :(
The earliest | could check was 1.9.3, and it already has order of keys 1, 2, 0.

off-topic: all-ruby is your friend :) https:/github.com/akr/all-ruby

hashes were unordered. I'll fix it.

% 3), so that's why it appears first in the

$ docker run —-it --rm rubylang/all-ruby ./all-ruby -e 'p (l1..6).to_a.inject({}) { Ilr, 1| (r[1 % 31 |l= []) <<
i; r }!'
ruby-0.49 -e:l: syntax error

(snip)
https://redmine.ruby-lang.org/projects/ruby-master/repository/git/revisions/1e10099e0919eda9464ef454b4920213eca658f3
https://github.com/akr/all-ruby

ruby-1.

ruby-1.
ruby-1.
ruby-1.

ruby-3.

8.7-p374
9.0-0

05/26/2025

loo®

—e:1l: undefined method

exit 1
{0=>[3,

{0=>13,
{1=>11,

{1=>11,

6]/

6],
41,

4],

1=>[1,

1=>[1,
2=>[2,

2=>[2,

41,

4],
51,

51,

“inject' for

2=>[2,

2=>[2,
0=>[3,

0=>[3,

5]}

51}
61}

[]1:Array

(NameError)

22


http://www.tcpdf.org

